<?php

class CredibanCoPaymentGateModuleFrontController extends ModuleFrontController
{
    /** @var CredibanCoPayment */
    public $module;
    public $display_column_left = false;
    public $display_column_right = false;

    public function initContent()
    {

        parent::initContent();
        $id_order = Tools::getValue('id_order');
        $order = new Order($id_order);

        if ($this->context->customer->id != $order->id_customer)
            Tools::redirect($this->context->link->getPageLink('history'));

        $order_module = Module::getInstanceByName($order->module);

        if (!$id_order || $order_module->id != $this->module->id)
            Tools::redirect($this->context->link->getPageLink('history'));

        $check_db_values = $this->module->getPaymentGateValues($id_order);


        $auth_canceled = $check_db_values['order_status'] == CredibanCo::_AUTHORIZATION_CANCELED_;
        $auth_failed = $check_db_values['order_status'] == CredibanCo::_AUTHORIZATION_FAILED_;

        if (!$check_db_values || $auth_canceled || $auth_failed) {

            $request_values = $this->module->registerInPaymentGate($id_order);



            if ($request_values === true) {
                $db_values = $this->module->getPaymentGateValues($id_order);
                if (!$db_values) {
                    $this->context->smarty->assign(
                        array(
                            'presta15' => Tools::version_compare(_PS_VERSION_, '1.6', '<'),
                            'order_error_code' => __LINE__,
                            'order_error_message' => 'ErrorCode '
                        )
                    );
                    $this->setTemplate('paymentfail.tpl');

                } else {
                    Tools::redirect($db_values['form_url'], '');
                }

            } else {
                $this->context->smarty->assign(
                    array(
                        'presta15' => Tools::version_compare(_PS_VERSION_, '1.6', '<'),
                        'order_error_code' => $request_values['errorcode'],
                        'order_error_message' => $request_values['errormessage']
                    )
                );
                $this->setTemplate('paymentfail.tpl');
            }

        } else {
            Tools::redirect($check_db_values['form_url'], '');
        }
    }
}